/*
oop_ex103b.cpp
Virtual Destructors
*/


#include <iostream>

using namespace std;

class shape
{
public:
	virtual void move(int x, int y) { cout << "do move shape by (" << x << ", " << y << ")" << endl; }
	virtual void draw() { cout << "do draw shape" << endl; }

	virtual ~shape() { cout << "~shape()" << endl; } // declare destructor as a virtual function
	//~shape(){ cout<<"~shape()"<<endl; } // destructor is a non-virtual function
};


class circle : public shape
{
public:
	void move(int x, int y) { cout << "do move circle by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw circle" << endl; }
	~circle() { cout << "~circle()" << endl; }
};


class triangle : public shape
{
public:
	void move(int x, int y) { cout << "do move triangle by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw triangle" << endl; }
	~triangle() { cout << "~triangle()" << endl; }
};


class square : public triangle
{
public:
	void move(int x, int y) { cout << "do move square by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw square" << endl; }
	~square() { cout << "~square()" << endl; }
};



void main()
{
	/*
	shape sh;
	circle ci;
	triangle tr;
	square sq;

	shape* ptr[4] = { &sh, &ci, &tr, &sq};
	*/
	shape* sh = new shape();
	circle* ci = new circle();
	triangle* tr = new triangle();
	square* sq = new square();

	shape* ptr[4] = { sh, ci, tr, sq };

	for (int i = 0; i < 4; i++)
		ptr[i]->draw();

	for (int i = 0; i < 4; i++)
		ptr[i]->move(i, i);

	for (int i = 0; i < 4; i++)
		delete ptr[i];

	system("pause");
}