/*
oop_ex104.cpp
Pure Virtual Functions and Abstract Classes
*/


#include <iostream>

using namespace std;

//abstract base class
class shape
{
public:
	virtual void move(int, int) = 0; //pure virtual function
	virtual void draw() = 0;			  //pure virtual function
	//virtual void draw(){ cout<<"do draw shape"<<endl; } = 0; //... can't have a body
};


//concrete derived classes
class circle : public shape
{
public:
	void move(int x, int y) { cout << "do move circle by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw circle" << endl; }
};


class triangle : public shape
{
public:
	void move(int x, int y) { cout << "do move triangle by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw triangle" << endl; }
};


class square : public triangle
{
public:
	void move(int x, int y) { cout << "do move square by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw square" << endl; }
};



void main()
{
	//shape sh;	//cannot instantiate abstract class
	circle ci;
	triangle tr;
	square sq;

	shape* ptr[3] = { &ci, &tr, &sq };	//can create pointers for abstract class
	shape& ref = ci;							//can create references for abstract class

	for (int i = 0; i < 3; i++)
		ptr[i]->draw();

	for (int i = 0; i < 3; i++)
		ptr[i]->move(i, i);

	system("pause");
}