/*
oop_ex106.cpp
Pure Virtual Functions and Abstract Classes
*/


#include <iostream>

using namespace std;

//abstract base class
class shape
{
public:
	virtual void move(int, int) = 0; //pure virtual function
	virtual void draw() = 0;			  //pure virtual function
};


//concrete derived classes
class circle : public shape
{
public:
	void move(int x, int y) { cout << "do move circle by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw circle" << endl; }
};


class triangle : public shape
{
public:
	void move(int x, int y) { cout << "do move triangle by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw triangle" << endl; }
	
	//rotate is a newly added function (undefined in shape)
	virtual void rotate(int a) { cout << "do rotate triangle by " << a << " degrees" << endl; }
};


class square : public triangle
{
public:
	void move(int x, int y) { cout << "do move square by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw square" << endl; }
	
	void rotate(int a) { cout << "do rotate square by " << a << " degrees" << endl; }
	//virtual void rotate(int a) { cout << "do rotate square by " << a << " degrees" << endl; }
};



void main()
{
	circle ci;
	triangle tr;
	square sq;

	shape* ptr[3] = { &ci, &tr, &sq };
	shape& ref = ci;

	for (int i = 0; i<3; i++)
		ptr[i]->draw();

	for (int i = 0; i<3; i++)
		ptr[i]->move(i, i);

	//for(int i=1; i<3; i++)
	//	ptr[i]->rotate(i*30);	//cannot call any function undefined in shape

	((square*)ptr[2])->rotate(90);  //downcasting is required

	((triangle*)ptr[2])->rotate(90); //OK too. The outcome is... Why?
	
	system("pause");
}