/*
oop_ex107.cpp
Pure Virtual Functions and Abstract Classes
*/


#include <iostream>
#include <string>
using namespace std;

//abstract base class
class shape
{
public:
	virtual string getType() = 0;
	virtual void move(int, int) = 0;	//pure virtual function
	virtual void draw() = 0;				//pure virtual function
};


//concrete derived classes
class circle : public shape
{
public:
	string getType() {	string type = "circle"; return  type; }
	void move(int x, int y) { cout << "do move circle by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw circle" << endl; }
};


class triangle : public shape
{
public:
	string getType() { string type = "triangle"; return type; }
	void move(int x, int y) { cout << "do move triangle by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw triangle" << endl; }
	
	virtual void rotate(int a) { cout << "do rotate triangle by " << a << " degrees" << endl; }
};


class square : public triangle
{
public:
	string getType() {	string type = "square"; return type;}
	void move(int x, int y) { cout << "do move square by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw square" << endl; }
	
	void rotate(int a) { cout << "do rotate square by " << a << " degrees" << endl; }
};


//This function can take and handle all kind of shapes because .....
void print(shape* s)
{
	cout << "I am a " << s->getType() << endl;
}


void main()
{
	circle ci;
	triangle tr;
	square sq;

	shape* ptr[3] = { &ci, &tr, &sq };
	shape& ref = ci;

	for (int i = 0; i < 3; i++)
		ptr[i]->draw();

	for (int i = 0; i < 3; i++)
		ptr[i]->move(i, i);

	for (int i = 0; i < 3; i++)
		print(ptr[i]);

	for (int i = 0; i < 3; i++)
	{
		if (ptr[i]->getType() == "triangle")
			((triangle*)ptr[i])->rotate(30);
		else if (ptr[i]->getType() == "square")
			((square*)ptr[i])->rotate(30);
	}

	system("pause");
}