/*
oop_ex108.cpp
Pure Virtual Functions and Abstract Classes
*/


#include <iostream>
#include <string>
using namespace std;

//abstract base class
class shape
{
public:
	virtual string getType() = 0;
	virtual void move(int, int) = 0;	//pure virtual function
	virtual void draw() = 0;				//pure virtual function
};


//concrete derived classes
class circle : public shape
{
public:
	string getType() { return "circle"; }
	void move(int x, int y) { cout << "do move circle by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw circle" << endl; }
};


class triangle : public shape
{
public:
	string getType() { return "triangle"; }
	void move(int x, int y) { cout << "do move triangle by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw triangle" << endl; }
};


class square : public triangle
{
public:
	string getType() { return "square"; }
	void move(int x, int y) { cout << "do move square by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw square" << endl; }
};


// a newly added class in the hierarchy
class ellipse : public circle
{
public:
	string getType() { return "ellipse"; }
	void move(int x, int y) { cout << "do move ellipse by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw ellipse" << endl; }
};



void print(shape* s)
{
	cout << "I am a " << s->getType() << endl;
}



void main()
{
	circle ci;
	triangle tr;
	//square sq;
	ellipse sq;		//the only change

	shape* ptr[3] = { &ci, &tr, &sq };
	shape& ref = ci;

	for (int i = 0; i<3; i++)
		ptr[i]->draw();

	for (int i = 0; i<3; i++)
		ptr[i]->move(i, i);

	for (int i = 0; i<3; i++)
		print(ptr[i]);
	
	system("pause");
}